(*               Jean-Francois Monin              *)
(*             Verimag Grenoble - 2004            *)

(** * Functional combinators *)

Definition seq (A B C : Type) (f : B -> C) (g : A -> B) (x : A) := f (g x).
Implicit Arguments seq [A B C].

Notation "f  'o'  g" := (seq f g) (at level 5, right associativity).

Definition seq2 (A B C D : Set) (f : D -> A) (g : B -> C -> D) 
  (x : B) (y : C) := f (g x y).
Implicit Arguments seq2 [A B C D].

Notation "f 'o2' g" := (seq2 f g) (at level 5, right associativity).

Lemma rew_apply :
 forall (A B : Set) (f g : A -> B), f = g -> forall x : A, f x = g x.
Proof.
  intros A B f g E x; case E; reflexivity.
Qed.
Implicit Arguments rew_apply [A B f g].
